Saturn Assembler                                       Thu Sep 02 00:27:10 2010
V3.0.9 (04/15/2007)                                      doromp.a       Page    1

    1               **********************************************************************
    2               * Author:       Han Duong
    3               * Email:        hduong_ihatespam@ju.edu (remove _ihatespam)
    4               * Modulename    DOROMP2
    5               * Date:         August 31, 2010
    6               **********************************************************************
    7               * File  doromp.s        7
    8
    9               **********************************************************************
   10               *               DOROMP2 specification
   11               **********************************************************************
   12               * ASSEMBLE
   13               *               CON(5)  =DOROMP2
   14               *               CON(3)  libid           xxx
   15               *               CON(3)  libcmd          yyy
   16               * RPL
   17               *
   18               * Works virtually the same as DOROMP, but assumes that the object
   19               * contained in ROMPTR xxx yyy is a compressed string: "BZ...". This
   20               * library adds support for auto-decompression WITHOUT first copying
   21               * the compressed string to TEMPOB (even if from a covered port), and
   22               * auto-execution. To the user, DOROMP2 objects are virtually the
   23               * same as DOROMP objects. In fact, all a DOROMP2 object does is it
   24               * looks for the corresponding ROMPTR with the same libid and libcmd,
   25               * decompresses the object found in that ROMPTR, and executes it.
   26               *
   27               * The config code injects the necessary code for supporting DOROMP2
   28               * into a safe area in RAM. The injected code looks like:
   29               *
   30               * ASSEMBLE
   31               *               CON(5)  romp2_spanner
   32               *               CON(5)  romp2_skipper
   33               *               CON(5)  =PRLG
   34               *               GOVLNG  romp2_executor
   35               * RPL
   36               **********************************************************************
   37               * Example:      Suppose we know that ROMPTR 3F0 2 contains an object
   38               *               that has been compressed. Then we can execute the
   39               *               compressed code via
   40               *
   41               *               ASSEMBLE
   42               *                       CON(5)  =DOROMP2
   43               *                       CON(3)  #3F0
   44               *                       CON(3)  #002
   45               *               RPL
   46               *
   47               * NOTES:        This is merely a proof of concept. Ideally we would do
   48               *               things like check to make sure that the pointee of the
   49               *               DOROMP2 object exists and is a valid compressed BZ
   50               *               string. An excercise for the reader...
   51               **********************************************************************
   52               * File  doromp.s        51
   53               * ROMID set to 200
   54               * File  doromp.s        52
   55
   56               * File  doromp.s        53
   57               * ASSEMBLE
   58               * File  doromp.s        54
   59               ROMID#          EQU     #200
   60               * File  doromp.s        55
   61               =DOROMP2        EQU     #80A0A                  change this as needed
   62               * File  doromp.s        56
   63               =SpanROMP2      EQU     (DOROMP2)-10
   64               * File  doromp.s        57
   65               =SkipROMP2      EQU     (DOROMP2)-5
   66               * File  doromp.s        58
   67               =gc1retc        EQU     #02D59
   68               * File  doromp.s        59
   69               =skipromp       EQU     #03094
   70               * File  doromp.s        60
   71 00000         =xxCONFIG
   72               * File  doromp.s        61
   73               * RPL
   74               * File  doromp.s        62
   75 00000 00000           CON(5)  =DOCOL
   76               * File  doromp.s        63
   77 00005 00000           CON(5)  =SIXTYFOUR
   78 0000A 00000           CON(5)  =TestUserFlag
   79               * File  doromp.s        64
   80 0000F 00000           CON(5)  =case
   81 00014 00000           CON(5)  =DOCOL
   82 00019 00000           CON(5)  =DOCSTR
   83 0001E 52000           CON(5)  37
   84 00023 44F425F         NIBASC  \DOROMP2 disabled\
            4D40523
            024696371626C65646

   85 00043 00000           CON(5)  =FlashMsg
   86 00048 00000           CON(5)  =ERRBEEP
   87 0004D 00000           CON(5)  =SEMI
   88               * File  doromp.s        65
   89
   90               * File  doromp.s        66
   91               * CODE
   92 00052 00000           CON(5)  =DOCODE
   93 00057 52000           REL(5)  LBL000
   94               * File  doromp.s        67
   95 0005C 132                     AD0EX
   96               * File  doromp.s        68
   97 0005F 1B00000                 D0=(5)  =USEROB
   98               * File  doromp.s        69
   99 00066 146                     C=DAT0  A
  100               * File  doromp.s        70
  101 00069 132                     AD0EX
  102               * File  doromp.s        71
  103 0006C 81B4                    A=PC
  104               * File  doromp.s        72
  105 00070 8B2                     ?A<C    A               * PC < USEROB ?
  106               * File  doromp.s        73
  107 00073 20                      GOYES   +
  108               * File  doromp.s        74
  109 00075 8D00000 +               GOVLNG  =PushT/FLoop
  110               * File  doromp.s        75
  111               * ENDCODE
  112 0007C         LBL000
  113               * File  doromp.s        76
  114 0007C 00000           CON(5)  =case
  115 00081 00000           CON(5)  =DOCOL
  116 00086 00000           CON(5)  =DOCSTR
  117 0008B B2000           CON(5)  43
  118 00090 44F425F         NIBASC  \DOROMP2 lib covered\
            4D40523
            02C696260236F66756275646

  119 000B6 00000           CON(5)  =FlashMsg
  120 000BB 00000           CON(5)  =ERRBEEP
  121 000C0 00000           CON(5)  =SEMI
  122               * File  doromp.s        77
  123
  124               * File  doromp.s        78
  125 000C5 00000           CON(5)  =DOBINT
  126 000CA 00200           CON(5)  =ROMID#
  127 000CF 00000           CON(5)  =TOSRRP
  128               * File  doromp.s        79
  129
  130               * File  doromp.s        80
  131               * dope up our StartupProc
  132               * File  doromp.s        81
  133 000D4 00000           CON(5)  ='
  134               * File  doromp.s        82
  135 000D9 00000           CON(5)  =DOCOL
  136               * File  doromp.s        83
  137 000DE 00000           CON(5)  ='
  138 000E3 00000           CON(5)  =StartupProc
  139               * File  doromp.s        84
  140 000E8 00000           CON(5)  =>R
  141 000ED 00000           CON(5)  ='R
  142 000F2 00000           CON(5)  =>R
  143               * File  doromp.s        85
  144 000F7 00000           CON(5)  ='REVAL
  145               * File  doromp.s        86
  146
  147               * File  doromp.s        87
  148               * CODE
  149 000FC 00000           CON(5)  =DOCODE
  150 00101 06000           REL(5)  LBL001
  151               * File  doromp.s        88
  152 00106 136                     CD0EX
  153               * File  doromp.s        89
  154 00109 06                      RSTK=C
  155               **********************************************************************
  156               * Insert spanromp into RAM at address given by (=DOROMP2)-10
  157               **********************************************************************
  158               * File  doromp.s        93
  159 0010B 1B00A08                 D0=(5)  =SpanROMP2
  160               * File  doromp.s        94
  161 00112 81B4                    A=PC
  162               * File  doromp.s        95
  163 00116 342A000                 LC(5)   (spanromp2)-(*)
  164               * File  doromp.s        96
  165 0011D C2                      C=C+A   A
  166               * File  doromp.s        97
  167 0011F 144                     DAT0=C  A
  168               * File  doromp.s        98
  169 00122 164                     D0=D0+  5
  170               **********************************************************************
  171               * Insert skipromp into RAM at address given by (=DOROMP2)-5
  172               **********************************************************************
  173               * File  doromp.s        102
  174 00125 3449030                 LC(5)   =skipromp
  175               * File  doromp.s        103
  176 0012C 144                     DAT0=C  A
  177               * File  doromp.s        104
  178 0012F 164                     D0=D0+  5
  179               **********************************************************************
  180               * Insert code for DOROMP at address given by (=DOROMP)
  181               **********************************************************************
  182               * File  doromp.s        108
  183 00132 36CF820                 LC(7)   #D8028FC        =PRLG and GOVLNG
            8D
  184               * File  doromp.s        109
  185 0013B 15C6                    DAT0=C  7
  186               * File  doromp.s        110
  187 0013F 166                     D0=D0+  7
  188               * File  doromp.s        111
  189 00142 81B4                    A=PC
  190               * File  doromp.s        112
  191 00146 3485000                 LC(5)   (doromp2)-(*)
  192               * File  doromp.s        113
  193 0014D C2                      C=C+A   A
  194               * File  doromp.s        114
  195 0014F 144                     DAT0=C  A
  196               * File  doromp.s        115
  197 00152 07                      C=RSTK
  198               * File  doromp.s        116
  199 00154 136                     CD0EX
  200               * File  doromp.s        117
  201 00157 142                     A=DAT0  A
  202               * File  doromp.s        118
  203 0015A 164                     D0=D0+  5
  204               * File  doromp.s        119
  205 0015D 808C                    PC=(A)
  206               * File  doromp.s        120
  207               * ENDCODE
  208 00161         LBL001
  209               * File  doromp.s        121
  210 00161 00000           CON(5)  =SEMI
  211               * File  doromp.s        122
  212
  213               * File  doromp.s        123
  214               * CODE
  215 00166 00000           CON(5)  =DOCODE
  216 0016B D1000           REL(5)  LBL002
  217               * File  doromp.s        124
  218 00170 8F00000                 GOSBVL  =PopASavptr     inject insertion code into
  219               * File  doromp.s        125
  220 00177 1B00000                 D0=(5)  =FIRSTPROC      default FIRSTPROC
  221               * File  doromp.s        126
  222 0017E 140                     DAT0=A  A
  223               * File  doromp.s        127
  224 00181 8D00000                 GOVLNG  =GETPTRLOOP
  225               * File  doromp.s        128
  226               * ENDCODE
  227 00188         LBL002
  228               * File  doromp.s        129
  229 00188 00000           CON(5)  =SEMI
  230               * File  doromp.s        130
  231
  232               * File  doromp.s        131
  233               * ASSEMBLE
  234               **********************************************************************
  235               * Code for garbage collection and returning to address in C[A]
  236               **********************************************************************
  237               *gc1retc        RSTK=C
  238               *               GOSBVL  =SAVPTR
  239               *               D0=(5)  =OSAVE
  240               *               DAT0=A  A
  241               *               GOSBVL  =GARBAGECOL
  242               *               D0=(5)  =OSAVE
  243               *               A=DAT0  A
  244               *               C=0     A
  245               *               DAT0=C  A
  246               *               GOSBVL  =GETPTR
  247               *               D=D-1   A
  248               *               RTNNC
  249               *               D=0     A
  250               *               GOVLNG  =DOMEMERR
  251               **********************************************************************
  252               * Do garbage collection and continue with doromp2 code
  253               **********************************************************************
  254               * File  doromp.s        152
  255 0018D 81B5    gcdoromp2       C=PC
  256               * File  doromp.s        153
  257 00191 818F2F                  C=C+CON A,(romp2rtn)-(*)
  258               *               GOTO    gc1retc         4 nibbles
  259               * File  doromp.s        155
  260 00197 8D95D20                 GOVLNG  =gc1retc        7 nibbles
  261               **********************************************************************
  262               * Indirect execution of DOROMP2; aka =DOROMP2
  263               **********************************************************************
  264               * File  doromp.s        159
  265 0019E 4EE     doromp2         GOC     gcdoromp2       3 nibbles
  266               * File  doromp.s        160
  267 001A1 1C4     romp2rtn        D1=D1-  5
  268               * File  doromp.s        161
  269 001A4 141                     DAT1=A  A
  270               * File  doromp.s        162
  271 001A7 81B4                    A=PC
  272               * File  doromp.s        163
  273 001AB 3492000                 LC(5)   (execromp2)-(*)
  274               * File  doromp.s        164
  275 001B2 CA                      A=A+C   A
  276               * File  doromp.s        165
  277 001B4 808C                    PC=(A)                  run romp2 executor
  278               **********************************************************************
  279               * Direct execution of ROMP2
  280               **********************************************************************
  281               * File  doromp.s        169
  282 001B8 184     spanromp2       D0=D0-  5               D0 -> romp2
  283               * File  doromp.s        170
  284 001BB 132                     AD0EX
  285               * File  doromp.s        171
  286 001BE 130                     D0=A                    A[A] = ->romp2
  287               * File  doromp.s        172
  288 001C1 16A                     D0=D0+  11              D0 -> next obj in runstream
  289               * File  doromp.s        173
  290 001C4 CF                      D=D-1   A               prepare to push pointer
  291               * File  doromp.s        174
  292 001C6 67DF                    GOTO    doromp2
  293               * File  doromp.s        175
  294               * RPL
  295               **********************************************************************
  296               *               BZUEval: and BZUEval
  297               **********************************************************************
  298               * Description:  ROMPTRs for direct execution of compressed objects
  299               *               Objects are decompressed without copying the source
  300               *               object to TEMPOB. The decompressed object is then
  301               *               executed.
  302               *
  303               * Usage:        :: ... BZUEval: Program ;
  304               *
  305               *               or
  306               *
  307               *               :: ... ' Program BZUEval ;
  308               *
  309               *               where Program is declared as a NULLNAME, xNAME, etc.
  310               *
  311               * WARNING:      Current implementation does not check validity of the
  312               *               compressed object. It assumes that Program is an XLIB
  313               *               whose content is a string of the form "BZ..." that is
  314               *               also the proper output from compression with BZ.
  315               **********************************************************************
  316               * File  doromp.s        197
  317 001CA         =BZUEval:
  318               * File  doromp.s        198
  319 001CA 00000           CON(5)  =DOCOL
  320               * File  doromp.s        199
  321 001CF 00000           CON(5)  ='R
  322               * pop ROMPTR from runstream
  323               * File  doromp.s        200
  324
  325               * File  doromp.s        201
  326               * ASSEMBLE
  327               * File  doromp.s        202
  328 001D4         execromp2                               label for romp2 executor
  329               * File  doromp.s        203
  330               * RPL
  331               * File  doromp.s        204
  332 001D4         =BZUEval
  333               * File  doromp.s        205
  334               * CODE
  335 001D4 00000           CON(5)  =DOCODE
  336 001D9 B0100           REL(5)  LBL003
  337               * File  doromp.s        206
  338 001DE 7C40                    GOSUB   popromp
  339               * File  doromp.s        207
  340 001E2 7A60                    GOSUB   getlibinfo      A[A] ->libnum; C[A] ->libaccess
  341               * File  doromp.s        208
  342 001E6 501                     GONC    +
  343               * File  doromp.s        209
  344
  345               * File  doromp.s        210
  346 001E9 3440000 noliberr        LC(5)   4               Undefined XLIB Name
  347               * File  doromp.s        211
  348 001F0 8D00000                 GOVLNG  =GPErrjmpC
  349               * File  doromp.s        212
  350
  351               * File  doromp.s        213
  352 001F7 7B80    +               GOSUB   prepbzu         set up registers for BZU
  353               * File  doromp.s        214
  354 001FB 8F00000                 GOSBVL  =aBZU           decompress object
  355               * File  doromp.s        215
  356 00202 7A10                    GOSUB   liboff
  357               * File  doromp.s        216
  358 00206 8F00000                 GOSBVL  =GETPTR
  359               * File  doromp.s        217
  360 0020D 110                     A=R0
  361               * File  doromp.s        218
  362 00210 808C                    PC=(A)
  363               **********************************************************************
  364               * File  doromp.s        220
  365 00214 11B     libon           C=R3                    configure lib; uses C[A], D0
  366               * File  doromp.s        221
  367 00217 8AA                     ?C=0    A
  368               * File  doromp.s        222
  369 0021A 00                      RTNYES
  370               * File  doromp.s        223
  371 0021C 81B3                    PC=C
  372               **********************************************************************
  373               * File  doromp.s        225
  374 00220 11B     liboff          C=R3                    unconfig lib; uses C[A], D0
  375               * File  doromp.s        226
  376 00223 8AA                     ?C=0    A
  377               * File  doromp.s        227
  378 00226 00                      RTNYES
  379               * File  doromp.s        228
  380 00228 21                      P=      1
  381               * File  doromp.s        229
  382 0022A 81B3                    PC=C
  383               **********************************************************************
  384               * File  doromp.s        231
  385 0022E 8F00000 popromp         GOSBVL  =PopASavptr
  386               * File  doromp.s        232
  387 00235 131                     D1=A
  388               * File  doromp.s        233
  389 00238 174                     D1=D1+  5               skip prologue
  390               * File  doromp.s        234
  391 0023B D2                      C=0     A
  392               * File  doromp.s        235
  393 0023D 1573                    C=DAT1  X
  394               * File  doromp.s        236
  395 00241 10B                     R3=C                    R3[A] = lib id
  396               * File  doromp.s        237
  397 00244 172                     D1=D1+  3
  398               * File  doromp.s        238
  399 00247 1573                    C=DAT1  X               R4[A] = lib cmd
  400               * File  doromp.s        239
  401 0024B 10C                     R4=C
  402               * File  doromp.s        240
  403 0024E 01                      RTN
  404               **********************************************************************
  405               * File  doromp.s        242
  406 00250 1F00000 getlibinfo      D1=(5)  =ROMPTAB
  407               * File  doromp.s        243
  408 00257 11B                     C=R3
  409               * File  doromp.s        244
  410 0025A D5                      B=C     A               B[A] = lib id
  411               * File  doromp.s        245
  412 0025C 1533                    A=DAT1  X               A[X] = number of libs
  413               * File  doromp.s        246
  414 00260 172                     D1=D1+  3
  415               * File  doromp.s        247
  416 00263 A3C     -               A=A-1   X               libcount--
  417               * File  doromp.s        248
  418 00266 400                     RTNC
  419               * File  doromp.s        249
  420 00269 1573                    C=DAT1  X
  421               * File  doromp.s        250
  422 0026D 17F                     D1=D1+  16
  423               * File  doromp.s        251
  424 00270 935                     ?C#B    X
  425               * File  doromp.s        252
  426 00273 0F                      GOYES   -
  427               * File  doromp.s        253
  428 00275 1CC                     D1=D1-  16-3
  429               * File  doromp.s        254
  430 00278 143                     A=DAT1  A               A[A] ->libnum
  431               * File  doromp.s        255
  432 0027B 174                     D1=D1+  5
  433               * File  doromp.s        256
  434 0027E 147                     C=DAT1  A               C[A] ->libaccess
  435               * File  doromp.s        257
  436 00281 10B                     R3=C                    R3[A] = ->libaccess
  437               * File  doromp.s        258
  438 00284 03                      RTNCC
  439               **********************************************************************
  440               * code below missing the following checks:
  441               *       1. ROMPTR pointed by DOROMP2 object is valid (i.e. the
  442               *          command number is not larger than there are commands)
  443               *       2. The object is a compressed string that starts with 'BZ'
  444               **********************************************************************
  445               * File  doromp.s        265
  446 00286 133     prepbzu         AD1EX                   D1 -> libnum
  447               * File  doromp.s        266
  448 00289 778F                    GOSUB   libon
  449               * File  doromp.s        267
  450 0028D 17C                     D1=D1+  3+5+5           skip libid, hash & msg tables
  451               * File  doromp.s        268
  452 00290 143                     A=DAT1  A               get link table offset
  453               * File  doromp.s        269
  454 00293 137                     CD1EX
  455               * File  doromp.s        270
  456 00296 C2                      C=C+A   A
  457               * File  doromp.s        271
  458 00298 135                     D1=C                    D1 -> link table
  459               * File  doromp.s        272
  460 0029B 179                     D1=D1+  5+5             skip prologue, length
  461               * File  doromp.s        273
  462 0029E 11C                     C=R4                    compute 5 * libcmd
  463               * File  doromp.s        274
  464 002A1 DA                      A=C     A
  465               * File  doromp.s        275
  466 002A3 C4                      A=A+A   A
  467               * File  doromp.s        276
  468 002A5 C4                      A=A+A   A
  469               * File  doromp.s        277
  470 002A7 C2                      C=C+A   A               C[A] = offset to libcmd
  471               * File  doromp.s        278
  472 002A9 133                     AD1EX
  473               * File  doromp.s        279
  474 002AC C2                      C=C+A   A
  475               * File  doromp.s        280
  476 002AE 135                     D1=C
  477               * File  doromp.s        281
  478 002B1 143                     A=DAT1  A
  479               * File  doromp.s        282
  480 002B4 C2                      C=C+A   A
  481               * File  doromp.s        283
  482 002B6 818F2D                  C=C+CON A,5+5+4         skip prologue, length, 'BZ'
  483               * File  doromp.s        284
  484 002BC 135                     D1=C                    D1 -> size of compressed data
  485               * File  doromp.s        285
  486 002BF 10C                     R4=C
  487               * File  doromp.s        286
  488 002C2 143                     A=DAT1  A
  489               * File  doromp.s        287
  490 002C5 775F                    GOSUB   liboff          in case of Insuff. Memory err
  491               * File  doromp.s        288
  492 002C9 D6                      C=A     A
  493               * File  doromp.s        289
  494 002CB 8F00000                 GOSBVL  =GETTEMP        allocate; error if no room
  495               * File  doromp.s        290
  496 002D2 132                     AD0EX                   save pointer to tempob
  497               * File  doromp.s        291
  498 002D5 131                     D1=A                    D1 -> hole in tempob
  499               * File  doromp.s        292
  500 002D8 783F                    GOSUB   libon           reconfig lib
  501               * File  doromp.s        293
  502 002DC 11C                     C=R4
  503               * File  doromp.s        294
  504 002DF 134                     D0=C                    D0 -> compressed data
  505               * File  doromp.s        295
  506 002E2 01                      RTN
  507               * File  doromp.s        296
  508               * ENDCODE
  509 002E4         LBL003
  510               * File  doromp.s        297
  511 002E4 00000           CON(5)  =SEMI
Saturn Assembler                                       Thu Sep 02 00:27:10 2010
V3.0.9 (04/15/2007)   Symbol Table                       doromp.a       Page    2

 '                                 Ext                   -   133   137
 'R                                Ext                   -   141   321
 'REVAL                            Ext                   -   144
 >R                                Ext                   -   140   142
=BZUEval                           Rel     468 #000001D4 -   332
=BZUEval:                          Rel     458 #000001CA -   317
 DOBINT                            Ext                   -   125
 DOCODE                            Ext                   -    92   149   215
                                         335
 DOCOL                             Ext                   -    75    81   115
                                         135   319
 DOCSTR                            Ext                   -    82   116
=DOROMP2                           Abs  526858 #00080A0A -    61    63    65
 ERRBEEP                           Ext                   -    86   120
 FIRSTPROC                         Ext                   -   220
 FlashMsg                          Ext                   -    85   119
 GETPTR                            Ext                   -   358
 GETPTRLOOP                        Ext                   -   224
 GETTEMP                           Ext                   -   494
 GPErrjmpC                         Ext                   -   348
 LBL000                            Rel     124 #0000007C -   112    93
 LBL001                            Rel     353 #00000161 -   208   150
 LBL002                            Rel     392 #00000188 -   227   216
 LBL003                            Rel     740 #000002E4 -   509   336
 PopASavptr                        Ext                   -   218   385
 PushT/FLoop                       Ext                   -   109
 ROMID#                            Abs     512 #00000200 -    59   126
 ROMPTAB                           Ext                   -   406
 SEMI                              Ext                   -    87   121   210
                                         229   511
 SIXTYFOUR                         Ext                   -    77
=SkipROMP2                         Abs  526853 #00080A05 -    65
=SpanROMP2                         Abs  526848 #00080A00 -    63   159
 StartupProc                       Ext                   -   138
 TOSRRP                            Ext                   -   127
 TestUserFlag                      Ext                   -    78
 USEROB                            Ext                   -    97
 aBZU                              Ext                   -   354
 case                              Ext                   -    80   114
 doromp2                           Rel     414 #0000019E -   265   191   292
 execromp2                         Rel     468 #000001D4 -   328   273
=gc1retc                           Abs   11609 #00002D59 -    67   260
 gcdoromp2                         Rel     397 #0000018D -   255   265
 getlibinfo                        Rel     592 #00000250 -   406   340
 lBm10                             Rel     611 #00000263 -   416   426
 lBp10                             Rel     117 #00000075 -   109   107
 lBp11                             Rel     503 #000001F7 -   352   342
 liboff                            Rel     544 #00000220 -   374   356   490
 libon                             Rel     532 #00000214 -   365   448   500
 noliberr                          Rel     489 #000001E9 -   346
 popromp                           Rel     558 #0000022E -   385   338
 prepbzu                           Rel     646 #00000286 -   446   352
 romp2rtn                          Rel     417 #000001A1 -   267   257
=skipromp                          Abs   12436 #00003094 -    69   174
 spanromp2                         Rel     440 #000001B8 -   282   163
=xxCONFIG                          Rel       0 #00000000 -    71
Saturn Assembler                                       Thu Sep 02 00:27:10 2010
V3.0.9 (04/15/2007)   Statistics                         doromp.a       Page    3

Input Parameters

  Source file name is doromp.a

  Listing file name is doromp.l

  Object file name is doromp.o

  Flags set on command line
    None

Warnings:

  None

Errors:

  None
